<p align="center"><a href="https://kbrsh.github.io/moon" target="_blank"><img width="100" src="https://raw.githubusercontent.com/kbrsh/moon/gh-pages/img/logo.png"></a></p>
<h1 align="center">Moon</h1>
<p align="center">The minimal & fast UI library.</p>
<p align="center">
	<a href="https://travis-ci.org/kbrsh/moon"><img src="https://travis-ci.org/kbrsh/moon.svg?branch=master" alt="Build Status"></a>
	<a href="https://codecov.io/gh/kbrsh/moon"><img src="https://codecov.io/gh/kbrsh/moon/branch/master/graph/badge.svg" alt="Code Coverage"></a>
	<a href="https://moon-slack.herokuapp.com"><img src="https://moon-slack.herokuapp.com/badge.svg" alt="Slack"></a>
	<a href="https://kbrsh.github.io/license"><img src="https://img.shields.io/badge/license-MIT-blue.svg" alt="License"></a>
</p>
<p align="center">
	<a href="https://saucelabs.com/u/KingPixil"><img src="https://saucelabs.com/browser-matrix/KingPixil.svg" alt="Browser Support Table"></a>
</p>

### Summary

- :tada: Small file size (3kb minified + gzip)
- :zap: Blazing fast performance
- :rocket: Minimal & intuitive API
- :hammer: Compose with components

### About

Moon is a JavaScript library with a minimal API and fast view compiler. It splits up a web application into two parts: the view and the data. The view is responsible for displaying the data to the user. Moon compiles the view into a JavaScript program running on a 3kb runtime capable of creating, updating, and destroying the view. The data is a simple object with access to the Moon API for updating itself.

### Usage

See [the documentation.](https://kbrsh.github.io/moon)

### Contributing

Check the [CONTRIBUTING](/CONTRIBUTING.md) file for more information about this project and how to help.

### Support

Support Moon [on Patreon](https://patreon.com/kbrsh) to help sustain the development of the project. The maker of the project works on open source for free. If you or your company depend on this project, then it makes sense to donate to ensure that the project is maintained.

### License

Licensed under the [MIT License](https://kbrsh.github.io/license) by [Kabir Shah](https://kabir.sh)
